#!/usr/bin/env node
const fs = require("fs")
const path = require('path')

const ROOTPATH = process.cwd() 
const kkRootPath = path.resolve(__dirname,"../default/")



const copyFile = async (readFile,writeFile)=>{
	let readStream = fs.createReadStream(path.join(kkRootPath,readFile))
	let writeStream = fs.createWriteStream(path.join(ROOTPATH,writeFile))
	await readStream.pipe(writeStream)
	isComplete()
}
// 创建目录
let assetsPath = path.join(ROOTPATH,"assets")

if(!fs.existsSync(assetsPath)){
	fs.mkdirSync(assetsPath)
}

let configPath = path.join(ROOTPATH,"config")

if(!fs.existsSync(configPath)){
	fs.mkdirSync(configPath)
}

let envPath = path.join(configPath,"env")
if(!fs.existsSync(envPath)){
	fs.mkdirSync(envPath)
}

fs.copyFileSync(path.join(kkRootPath,"base.js"),path.join(envPath,"base.js"))
fs.copyFileSync(path.join(kkRootPath,"routes.js"),path.join(configPath,"routes.js"))


let srcPath = path.join(ROOTPATH,"src")

if(!fs.existsSync(srcPath)){
	fs.mkdirSync(srcPath)
}

let controllerPath = path.join(srcPath,"controller")

if(!fs.existsSync(controllerPath)){
	fs.mkdirSync(controllerPath)
}


fs.copyFileSync(path.join(kkRootPath,"index.js"),path.join(controllerPath,"index.js"))


let viewPath = path.join(ROOTPATH,"views")

if(!fs.existsSync(viewPath)){
	fs.mkdirSync(viewPath)
}

fs.copyFileSync(path.join(kkRootPath,"index.pug"),path.join(viewPath,"index.pug"))

fs.copyFileSync(path.join(kkRootPath,"app.js"),path.join(ROOTPATH,"app.js"))


console.log("init ready,please enjoy it!!!")