
const debug = require('debug')('kk:fastCache')
const {RedisClient,RedisStore} = require('./redis')

module.exports = (config = {}) => {

    let redis = RedisClient.create(config,config.key).client
    const store = new RedisStore(redis,config)

    const getCache = async (id) => store.get(id)
    const setCache = async (sid,obj,ttl) => store.set(obj,{sid,ttl})
    const hgetCache = async (key_name, field_name) => store.hget(key_name, field_name) 
    const deleteCache = async (sid)=>store.destroy(sid)

    return async (ctx, next) => {

        debug('enter')

        if (!redis) {
            return await next()
        }

        ctx.cache = {}
        ctx.cache.get = getCache
        ctx.cache.hget = hgetCache
        ctx.cache.set = setCache
        ctx.cache.destroy = deleteCache
        await next()
        
    }

}