const fs = require('fs')
const path = require('path')



module.exports = (dir) =>{

    class I18n{

        constructor(){
            this.locales = {}   
            this.currentLocale = 'zh-CN'
    
            let configPath = path.join(dir,'i18n.js')
    
            if(!fs.existsSync(configPath)){
                return
            }
            
            this.config = require(configPath) || {}
    
            let files = fs.readdirSync(path.join(dir,'locale'))
    
            for(let file of files){
                let k = file.split('.js')[0]
                this.locales[k] = require(path.join(dir,'locale',file))
            }
        }
    
        toJson(){
            return this.locales[this.currentLocale] || {}
        }
    
        parse(str){
            let locale = this.toJson()
            let list = !~str.indexOf('.') ? str.split('/') : str.split('.')
    
            let res = '',tmp = locale
    
            for(let i = 0 ;i<list.length;i++){
                tmp = tmp[list[i]]
                if(!tmp){
                    res = str
                    break
                }
                else if(i == list.length - 1){
                    res = tmp
                }
            }
            return res
        }
    
    }
    
    let i18n = new I18n()

    return async (ctx,next)=>{

        ctx.state.i18n = i18n
        ctx.state.__ = i18n.parse.bind(i18n)
    
        await next()
    }
} 