const Strategy = require('./strategy')
const url = require('url')
module.exports = class AutoLoginStrategy extends Strategy {
    constructor(options = {}) {
        super('autoLogin')
        this.options = options
    }

    async verify(ctx, options) {
        if (ctx.isAuthenticated()) {
            return null
        }
        let op = Object.assign({}, this.options, options || {})

        let name = op.cookieName || 'UP_NP'

        let cookie = ctx.getCookie(name)

        if (!cookie) {
            return null
        }

        ctx.query = {}

        ctx.query.redirect = (op.baseUrl || '') + ctx.originalUrl

        ctx.redirect(url.format({
            pathname: options.redirectUrl || '/user/autoLogin',
            query: ctx.query
        }))

        return false
    }
}