const Strategy = require('./strategy')

module.exports = class LoginStrategy extends Strategy{
    constructor(verify){
        super('login')
        this.verifyFunc = verify
    }

    async verify(ctx,options){
        
        if(!this.verifyFunc){
            return Promise.reject('function undefiend!')
        }

        if(options.beforVerify){
            await options.beforVerify(ctx)
        }

        let data = await this.verifyFunc(ctx.request.body || {},ctx.request)

        if(data === false){
            return Promise.reject('verify failed')
        }

        if(options.afterVerfify){
            await options.afterVerfify(ctx,data)
        }

        if(ctx.session){
            ctx.session.profile = data
            ctx.session.save()
        }

        return null
    }
}