const path = require('path')
const _ = require('lodash')
const fs = require('fs')
let redis = {}

module.exports = app => {
   
    let CONFIG_DIR = app.$$.CONFIG_DIR

    let env = process.env.NODE_ENV

    if (env === 'production') {
        redis = {
            host: 'redis-web-1.kktv2.com',
            port: 6379,
            password: '9bc34XX#13d10dc41',
            ttl : 20 * 60
        }
    } else {
        redis = {
            host: '10.4.2.223',
            port: 6379,
            password: 'youknowthat',
            ttl : 20 * 60
        }
    }

    let envPath = path.join(CONFIG_DIR, 'env/base.js')

    if(!fs.existsSync(envPath)){
        throw 'config setting empty'
    }

    let config = require(envPath)

    if (env) {
        let path2 = path.join(CONFIG_DIR, 'env',env + '.js')
        if(fs.existsSync(path2)){
            var cfg2 = require(path2)
            config = _.merge(config,cfg2)
        }
    }

    if (!config.redis) {
        config.redis = redis
    }
    
    if (config.version && !config.session) { //防止活动项目再次操作
        config.session = redis
        config.session.prefix = 'kk/game:'
    }

    app.$$.config = config


}