const fs = require('fs')
var debug = require('debug')('kk')


module.exports = (app,callback) => {

    if(!app.$$){
        throw 'it is not an kk web framework'
    }

    if(!app.$$.CONFIG_DIR || !fs.existsSync(app.$$.CONFIG_DIR)){
        throw 'config dir empty!'
    }

    require('./config')(app)

    if(callback){
        callback('config')
    }

    debug('setup views')
    require('./view')(app)
    if(callback){
        callback('views')
    }

    debug('setup middlewares')
    require('./middleware')(app)
    if(callback){
        callback('middleware')
    }
    
    debug('setup policy')
    require('./policy')(app)
    if(callback){
        callback('policy')
    }
    
    debug('setup routes')
    require('./routes')(app)
    if(callback){
        callback('routes')
    }

    debug('setup response')
    require('./response')(app)
    if(callback){
        callback('response')
    }
}