const fs = require('fs')
const path = require('path')

module.exports = app =>{

    let I18n = require(path.join(__dirname,'../middleware/i18n'))
    let Session = require(path.join(__dirname,'../middleware/session'))
    let FastCache = require(path.join(__dirname,'../middleware/fastCache'))
    let Utils = require(path.join(__dirname,'../middleware/utils'))
    
    let Redis = require(path.join(__dirname,'../middleware/redis'))

    app.use(I18n(app.$$.CONFIG_DIR))
    app.use(require(path.join(__dirname,'../middleware/cookie')))
    
    if(app.$$.config.redis){
        Redis && Redis.RedisClient.create(app.$$.config.redis,'redis')
    }

    if(app.$$.config.session){
        app.use(Session(app.$$.config.session))
    }
    if(app.$$.config.fastCache){
        app.use(FastCache(app.$$.config.fastCache))
    }

    app.use(Utils(app.LIFT_TIME,app.$$.config.publicPath))


    let dir = path.join(app.$$.SOURCE_DIR,'middleware')

    if(!fs.existsSync(dir)){
        return
    }

    let files = fs.readdirSync(dir)

    for(let file of files){
        app.use(require(path.join(dir,file)))
    }

}