var path = require('path')
var fs = require('fs')
const consolidate = require('consolidate')
const getPaths = require('get-paths')

const viewMiddleware = (pth,{extension,engineSource = consolidate,options = {},variable='state',map} = {}) =>{
    return (ctx,next)=>{
        if (ctx.render) return next()

        ctx.render = function(relPath,locals = {}){
            return getPaths(pth, relPath, extension).then(paths => {
                const suffix = paths.ext
                const state = Object.assign(locals, options, ctx[variable] || {})
                // deep copy partials
                state.partials = Object.assign({}, options.partials || {})
                ctx.type = 'text/html'
        
                const engineName = map && map[suffix] ? map[suffix] : suffix
    
                const render = engineSource[engineName]
      
                if (!engineName || !render)
                  return Promise.reject(
                    new Error(`Engine not found for the ".${suffix}" file extension`)
                  )
      
                return render(path.resolve(pth, paths.rel), state).then(html => {
                  ctx.body = html
                })
            })
        }

        return next()

    }

}

module.exports = app =>{


    let ext = 'pug'
    let variable = 'state'
    let viewPath = path.join(app.$$.CONFIG_DIR,'view.js')
    if(fs.existsSync(viewPath)){
        ext = require(viewPath).engine || ext
        variable = require(viewPath).variable || variable
    }
    app.use(viewMiddleware(app.$$.VIEW_DIR, { extension: ext ,variable}))
}