



/**
 * @param {Middleware|Array<Middleware>} middleware 
 * @returns {Promise}
 */
const createMethod = (middleware) => middleware


/**
 * @param {{[key:string]:{methods?:Array<"get|post|put|del">,url:string,bodyParser?:{multipart?:boolean}}}} config
 */
const createMeta = config => config


module.exports = {
    createMethod,
    createMeta
}


/**
 * This callback is displayed as a global member.
 * @callback Middleware
 * @param {Context>} context
 * @param {Promise<void>} next
 */


 /**
 * @callback setCookieCallback
 * @param {string} key
 * @param {string} str
 * @param {{maxAge?: number,expires?:Date,path?: string>}} ops
 */


  /**
 * @callback getCookieCallback
 * @param {string} key
 * @returns {string}
 */


/**
 * @callback CacheGetCallback
 * @param {string} sid
 * @returns {string}
 */

 /**
 * @callback CacheSetCallback
 * @param {string} sid
 * @param {object} obj
 * @param {number?} ttl
 * @returns {void}
 */


/**
 * @typedef {{getCookie:getCookieCallback,setCookie:setCookieCallback}} CookieExtends
 */


 /**
 * @typedef {{cookie:{get:CacheGetCallback,set:CacheSetCallback}}} CacheExtends
 */

 /**
 * @typedef {{session:{save:function()=>void,destroy:function()=>void,refresh:()=>void}}} SessionExtends
 */

 /**
  * @typedef {{state:{static_for:function(string,string),lifttime:number}}} StateExtends
  */

/**
 * @typedef {  StateExtends & import("koa").ParameterizedContext<any, {}> & SessionExtends & CacheExtends & CookieExtends } Context
 */
